Loading...
Searching...
No Matches
auth.h File Reference
GSM/GPRS/3G Authentication
`#include <stdint.h>`
`#include <osmocom/core/linuxlist.h>`
`#include <osmocom/core/utils.h>`

Go to the source code of this file.

## Data Structures

struct | osmo_sub_auth_data
| permanent (secret) subscriber auth data More...
struct | osmo_auth_vector
struct | osmo_auth_impl

## Macros

#define | OSMO_A5_MAX_KEY_LEN_BYTES (128/8)
#define | OSMO_MILENAGE_IND_BITLEN_MAX 28

## Enumerations

enum | osmo_sub_auth_type { OSMO_AUTH_TYPE_NONE = 0x00 , OSMO_AUTH_TYPE_GSM = 0x01 , OSMO_AUTH_TYPE_UMTS = 0x02 }
| Authentication Type (GSM/UMTS) More...
enum | osmo_auth_algo { OSMO_AUTH_ALG_NONE , OSMO_AUTH_ALG_COMP128v1 , OSMO_AUTH_ALG_COMP128v2 , OSMO_AUTH_ALG_COMP128v3 , OSMO_AUTH_ALG_XOR , OSMO_AUTH_ALG_MILENAGE , _OSMO_AUTH_ALG_NUM }
| Authentication Algorithm. More...

## Functions

static const char * | osmo_sub_auth_type_name (enum osmo_sub_auth_type val)
int | osmo_auth_gen_vec (struct osmo_auth_vector *vec, struct osmo_sub_auth_data *aud, const uint8_t *_rand)
| Generate authentication vector.
int | osmo_auth_gen_vec_auts (struct osmo_auth_vector *vec, struct osmo_sub_auth_data *aud, const uint8_t *auts, const uint8_t *rand_auts, const uint8_t *_rand)
| Generate authentication vector and re-sync sequence.
int | osmo_auth_register (struct osmo_auth_impl *impl)
| Register an authentication algorithm implementation with the core.
int | osmo_auth_load (const char *path)
| Load all available authentication plugins from the given path.
int | osmo_auth_supported (enum osmo_auth_algo algo)
| Determine if a given authentication algorithm is supported.
void | osmo_c4 (uint8_t *ck, const uint8_t *kc)
const char * | osmo_auth_alg_name (enum osmo_auth_algo alg)
| Get human-readable name of authentication algorithm.
enum osmo_auth_algo | osmo_auth_alg_parse (const char *name)
| Parse human-readable name of authentication algorithm.
void | osmo_auth_c3 (uint8_t kc[], const uint8_t ck[], const uint8_t ik[])

## Variables

const struct value_string | osmo_sub_auth_type_names []